import { _decorator, Component, Node, resources, SpriteFrame,rect, Sprite, log, AnimationClip,Animation, instantiate, Vec3, Texture2D, UITransform, Camera } from 'cc';
const { ccclass, property } = _decorator;



// 心得
/*

1 按钮所在的分组的摄像机必须是正交相机？
2 必须有一个的clearflags是DEPTH_ONLY

*/

@ccclass('Test')
export class Test extends Component {

    @property(Camera)
    spriteCamera:Camera = null;

    start() {
        this.loadActor();
    }

    update(deltaTime: number) {
        
    }

    onBtn1Click(){
        console.log("Btn1 click");
        let oldPos = this.spriteCamera.node.getPosition();
        oldPos.z -= 100;
        this.spriteCamera.node.setPosition(oldPos);

        let newPos = this.spriteCamera.node.getPosition();
        console.log("newPos:", newPos);
    }

    onBtn2Click(){
        console.log("Btn2 click");
    }

    loadActor(){
        console.log("begin load");
        resources.load("Imgs/Hero_P1/spriteFrame", SpriteFrame, (err: Error, spriteFrame: SpriteFrame) => {
            if (err) {
                console.log("load failed");
                log(err);
                return;
            }

            console.log("load success");

            //let spriteFrame = new SpriteFrame();
            //spriteFrame.texture = texture;
            
            let spriteFrames = []

            log(spriteFrame);
            for (let i = 0; i < 8; i++) {
                //spriteFrame.rect.set(rect(64 * i, 0, 64, 64));
                spriteFrame.reset({rect:rect(64 * i, 0, 64, 64)})
                //spriteFrame.rect.set
                spriteFrames.push(spriteFrame.clone());
            }

            //this.testNode.getComponent(Sprite).spriteFrame = spriteFrames[0];

            log(spriteFrames)

            
            let clip = AnimationClip.createWithSpriteFrames(spriteFrames, 16);
            clip.wrapMode = AnimationClip.WrapMode.Loop;
            clip.speed = 0.5

            for (let j = 1; j <= 5; j++){
                let childNode = this.node.getChildByName("Sprite").getChildByName("Sprite" + j);
                childNode.setScale(1, 1);
                childNode.active = false;
                let animCtrl = childNode.getComponent(Animation);
                animCtrl.addClip(clip, "anim");
                animCtrl.play("anim");

                let newWidth = childNode.getComponent(UITransform).contentSize.width * childNode.scale.x * 0.5;
                let newHeight = childNode.getComponent(UITransform).contentSize.height * childNode.scale.y * 0.5;
    
                for (let i = 0; i <= 63; i++){
                    let newNode = instantiate(childNode);
                    //newNode.setScale(0.5, 0.5)
                    this.node.addChild(newNode);
                    newNode.position.set(childNode.position.x + i % 8 * newWidth, childNode.position.y + Math.floor(i / 8) * newHeight);
                    newNode.active = true;
    
                    let animCtrlX = newNode.getComponent(Animation);
                    animCtrlX.addClip(clip, "anim");
                    animCtrlX.play("anim");
                    if (i < 2){
                        //console.log(newNode.layer);
                    }
                    
                }
            }
            
            
        });
    }
}


